<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SourceFile.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SourceFile.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SourceFile.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/SourceFile/Include.html">Include</a>:</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Information about an include directive in a SourceFile.</span></span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-string">    If the include directive required a macro expansion to get the filename,</span></span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-string">    the is_macro will return true. If the include directive was actually an</span></span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-string">    include_next, then is_next will return true.</span></span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SourceFile/Include.html#__init__">__init__</a>(self, target, name, is_macro, is_next):</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">        self.target = target</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The target SourceFile object being referenced.&quot;&quot;&quot;</span></span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        self.name = name</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The name by which the target is referenced.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno">21</span><span class="line">        self.is_macro = is_macro</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        <span class="py-string">&quot;&quot;&quot;True if the directive uses a macro.&quot;&quot;&quot;</span></span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        self.is_next = is_next</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        <span class="py-string">&quot;&quot;&quot;True if this is using #include_next (GNU extension).&quot;&quot;&quot;</span></span>
<a id="line25"></a><span class="lineno">25</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/SourceFile/MacroCall.html">MacroCall</a>:</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class to support mapping from positions in a preprocessed file</span></span>
<a id="line29"></a><span class="lineno">29</span><span class="line"><span class="py-string">    back to positions in the original file.&quot;&quot;&quot;</span></span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SourceFile/MacroCall.html#__init__">__init__</a>(self, name, start, end, expanded_start, expanded_end):</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">        self.name = name</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        <span class="py-string">&quot;The name of the macro being called.&quot;</span></span>
<a id="line35"></a><span class="lineno">35</span><span class="line">        self.start = start</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">        <span class="py-string">&quot;(line, column) pair indicating the start of the call.&quot;</span></span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        self.end = end</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        <span class="py-string">&quot;(line, column) pair indicating the end of the call.&quot;</span></span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        self.expanded_start = expanded_start</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        <span class="py-string">&quot;(line, column) pair indicating the start of the expansion in the preprocessed file.&quot;</span></span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        self.expanded_end = expanded_end</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        <span class="py-string">&quot;(line, column) pair indicating the end of the expansion in the preprocessed file.&quot;</span></span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/SourceFile/SourceFile.html">SourceFile</a>:</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">    <span class="py-string">&quot;&quot;&quot;The information about a file that the ASG was generated from.</span></span>
<a id="line46"></a><span class="lineno">46</span><span class="line"><span class="py-string">    Contains filename, all declarations from this file (even nested ones) and</span></span>
<a id="line47"></a><span class="lineno">47</span><span class="line"><span class="py-string">    includes (aka imports) from this file.&quot;&quot;&quot;</span></span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SourceFile/SourceFile.html#__init__">__init__</a>(self, name, abs_name, language, primary = False):</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Constructor&quot;&quot;&quot;</span></span>
<a id="line51"></a><span class="lineno">51</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        self.name = name</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The filename.&quot;&quot;&quot;</span></span>
<a id="line54"></a><span class="lineno">54</span><span class="line">        self.abs_name = abs_name</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The absolute filename.&quot;&quot;&quot;</span></span>
<a id="line56"></a><span class="lineno">56</span><span class="line">        self.annotations = {<span class="py-string">'language'</span>:language, <span class="py-string">'primary'</span>:primary}</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Dictionary with file annotations.&quot;&quot;&quot;</span></span>
<a id="line58"></a><span class="lineno">58</span><span class="line">        self.includes = []</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">        <span class="py-string">&quot;&quot;&quot;List of includes this file contains.&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno">60</span><span class="line">        self.declarations = []</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        <span class="py-string">&quot;&quot;&quot;List of declarations this file contains.&quot;&quot;&quot;</span></span>
<a id="line62"></a><span class="lineno">62</span><span class="line">        self.macro_calls = []</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">        <span class="py-string">&quot;&quot;&quot;List of macro calls this file contains.&quot;&quot;&quot;</span></span>
<a id="line64"></a><span class="lineno">64</span>
<a id="line65"></a><span class="lineno">65</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
